import{s as Ja,f as Ka,n as Qa,o as Xa}from"../chunks/scheduler.37c15a92.js";import{S as Za,i as ts,g as n,s as l,r as et,m as r,H as d,A as as,h as i,f as a,c as p,j as w,u as nt,x as m,n as h,B as b,k as V,y as o,a as e,v as it,d as lt,t as pt,w as mt}from"../chunks/index.7cb9c9b8.js";import{H as la,E as ss}from"../chunks/EditOnGithub.858acfec.js";function es(va){let u,ot,tt,rt,P,ht,$,da="Don’t worry. <strong>It’s normal if this seems complex to handle right now</strong>. But we’re going to see what this Clipped Surrogate Objective Function looks like, and this will help you to visualize better what’s going on.",ct,y,wa=`<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/recap.jpg" alt="PPO"/> <figcaption><a href="https://fse.studenttheses.ub.rug.nl/25709/1/mAI_2021_BickD.pdf">Table from &quot;Towards Delivering a Coherent Self-Contained
    Explanation of Proximal Policy Optimization&quot; by Daniel Bick</a></figcaption>`,gt,L,ba="We have six different situations. Remember first that we take the minimum between the clipped and unclipped objectives.",ut,H,ft,x,pa,Y,ya="the clipping does not apply since the ratio is between the range",vt,Da='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo separator="true">,</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon, 1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8389em;vertical-align:-0.1944em;"></span><span class="mord mathnormal">ϵ</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',dt,z,xa="In situation 1, we have a positive advantage: the <strong>action is better than the average</strong> of all the actions in that state. Therefore, we should encourage our current policy to increase the probability of taking that action in that state.",wt,I,_a="Since the ratio is between intervals, <strong>we can increase our policy’s probability of taking that action at that state.</strong>",bt,O,ka="In situation 2, we have a negative advantage: the action is worse than the average of all actions at that state. Therefore, we should discourage our current policy from taking that action in that state.",yt,j,Ca="Since the ratio is between intervals, <strong>we can decrease the probability that our policy takes that action at that state.</strong>",xt,E,_t,_,Ma=`<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/recap.jpg" alt="PPO"/> <figcaption><a href="https://fse.studenttheses.ub.rug.nl/25709/1/mAI_2021_BickD.pdf">Table from &quot;Towards Delivering a Coherent Self-Contained
    Explanation of Proximal Policy Optimization&quot; by Daniel Bick</a></figcaption>`,kt,k,ma,Ct,Ga='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon] </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',Mt,Tt,S,Ta="If, like in situation 3, the advantage estimate is positive (A&gt;0), then <strong>you want to increase the probability of taking that action at that state.</strong>",Pt,q,Pa="But if, like situation 4, the advantage estimate is negative, <strong>we don’t want to decrease further</strong> the probability of taking that action at that state. Therefore, the gradient is = 0 (since we’re on a flat line), so we don’t update our weights.",$t,A,Lt,C,$a=`<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/recap.jpg" alt="PPO"/> <figcaption><a href="https://fse.studenttheses.ub.rug.nl/25709/1/mAI_2021_BickD.pdf">Table from &quot;Towards Delivering a Coherent Self-Contained
    Explanation of Proximal Policy Optimization&quot; by Daniel Bick</a></figcaption>`,Ht,f,oa,zt,Ra='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',It,J,La="much higher than in the former policy.",Ot,B,Ha="If, like in situation 5, the advantage is positive, <strong>we don’t want to get too greedy</strong>. We already have a higher probability of taking that action at that state than the former policy. Therefore, the gradient is = 0 (since we’re on a flat line), so we don’t update our weights.",jt,D,za="If, like in situation 6, the advantage is negative, we want to decrease the probability of taking that action at that state.",Et,G,Ia="So if we recap, <strong>we only update the policy with the unclipped objective part</strong>. When the minimum is the clipped objective part, we don’t update our policy weights since the gradient will equal 0.",St,R,Oa="So we update our policy  only if:",qt,M,K,ra,At,Fa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo separator="true">,</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon, 1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8389em;vertical-align:-0.1944em;"></span><span class="mord mathnormal">ϵ</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',ha,Q,ja="Our ratio is outside the range, but <strong>the advantage leads to getting closer to the range</strong><ul><li>Being below the ratio but the advantage is &gt; 0</li> <li>Being above the ratio but the advantage is &lt; 0</li></ul>",Bt,c,X,Ea="You might wonder why, when the minimum is the clipped ratio, the gradient is 0.",ca,Dt,Ua='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>r</mi><mi>t</mi></msub><mo stretchy="false">(</mo><mi>θ</mi><mo stretchy="false">)</mo><mo>∗</mo><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> r_t(\\theta) * A_t </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0278em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mopen">(</span><span class="mord mathnormal" style="margin-right:0.02778em;">θ</span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Gt,Rt,Wa='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">(</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo stretchy="false">)</mo><mo>∗</mo><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> (1 - \\epsilon)* A_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">(</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Ft,Ut,Na='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">(</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">)</mo><mo>∗</mo><msub><mi>A</mi><mi>t</mi></msub></mrow><annotation encoding="application/x-tex"> (1 + \\epsilon)* A_t</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">(</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">)</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">∗</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Wt,Nt,g,ga,Z,Sa="we restrict the range that the current policy can vary from the old one.",ua,Vt,Va='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mn>1</mn><mo>+</mo><mi>ϵ</mi></mrow><annotation encoding="application/x-tex"> 1 + \\epsilon </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal">ϵ</span></span></span></span>',Yt,Jt,Ya='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mn>1</mn><mo>−</mo><mi>ϵ</mi></mrow><annotation encoding="application/x-tex"> 1 - \\epsilon </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.4306em;"></span><span class="mord mathnormal">ϵ</span></span></span></span>',Kt,Qt,F,qa="The final Clipped Surrogate Objective Loss for PPO Actor-Critic style looks like this, it’s a combination of Clipped Surrogate Objective function, Value Loss Function and Entropy bonus:",Xt,U,Aa,Zt,W,Ba='That was quite complex. Take time to understand these situations by looking at the table and the graph. <strong>You must understand why this makes sense.</strong> If you want to go deeper, the best resource is the article <a href="https://fse.studenttheses.ub.rug.nl/25709/1/mAI_2021_BickD.pdf" rel="nofollow">“Towards Delivering a Coherent Self-Contained Explanation of Proximal Policy Optimization” by Daniel Bick, especially part 3.4</a>.',ta,N,aa,at,sa;return P=new la({props:{title:"Visualize the Clipped Surrogate Objective Function",local:"visualize-the-clipped-surrogate-objective-function",headingTag:"h1"}}),H=new la({props:{title:"Case 1 and 2: the ratio is between the range",local:"case-1-and-2-the-ratio-is-between-the-range",headingTag:"h2"}}),E=new la({props:{title:"Case 3 and 4: the ratio is below the range",local:"case-3-and-4-the-ratio-is-below-the-range",headingTag:"h2"}}),A=new la({props:{title:"Case 5 and 6: the ratio is above the range",local:"case-5-and-6-the-ratio-is-above-the-range",headingTag:"h2"}}),N=new ss({props:{source:"https://github.com/huggingface/deep-rl-class/blob/main/units/en/unit8/visualize.mdx"}}),{c(){u=n("meta"),ot=l(),tt=n("p"),rt=l(),et(P.$$.fragment),ht=l(),$=n("p"),$.innerHTML=da,ct=l(),y=n("figure"),y.innerHTML=wa,gt=l(),L=n("p"),L.textContent=ba,ut=l(),et(H.$$.fragment),ft=l(),x=n("p"),pa=r("In situations 1 and 2, "),Y=n("strong"),Y.textContent=ya,vt=new d(!1),dt=l(),z=n("p"),z.innerHTML=xa,wt=l(),I=n("p"),I.innerHTML=_a,bt=l(),O=n("p"),O.textContent=ka,yt=l(),j=n("p"),j.innerHTML=Ca,xt=l(),et(E.$$.fragment),_t=l(),_=n("figure"),_.innerHTML=Ma,kt=l(),k=n("p"),ma=r("If the probability ratio is lower than"),Ct=new d(!1),Mt=r(", the probability of taking that action at that state is much lower than with the old policy."),Tt=l(),S=n("p"),S.innerHTML=Ta,Pt=l(),q=n("p"),q.innerHTML=Pa,$t=l(),et(A.$$.fragment),Lt=l(),C=n("figure"),C.innerHTML=$a,Ht=l(),f=n("p"),oa=r("If the probability ratio is higher than"),zt=new d(!1),It=r(", the probability of taking that action at that state in the current policy is "),J=n("strong"),J.textContent=La,Ot=l(),B=n("p"),B.innerHTML=Ha,jt=l(),D=n("p"),D.textContent=za,Et=l(),G=n("p"),G.innerHTML=Ia,St=l(),R=n("p"),R.textContent=Oa,qt=l(),M=n("ul"),K=n("li"),ra=r("Our ratio is in the range"),At=new d(!1),ha=l(),Q=n("li"),Q.innerHTML=ja,Bt=l(),c=n("p"),X=n("strong"),X.textContent=Ea,ca=r(" When the ratio is clipped, the derivative in this case will not be the derivative of the"),Dt=new d(!1),Gt=r("   but the derivative of either"),Rt=new d(!1),Ft=r(" or the derivative of"),Ut=new d(!1),Wt=r(" which both = 0."),Nt=l(),g=n("p"),ga=r("To summarize, thanks to this clipped surrogate objective, "),Z=n("strong"),Z.textContent=Sa,ua=r(" Because we remove the incentive for the probability ratio to move outside of the interval since the clip forces the gradient to be zero. If the ratio is >"),Vt=new d(!1),Yt=r(" or <"),Jt=new d(!1),Kt=r(" the gradient will be equal to 0."),Qt=l(),F=n("p"),F.textContent=qa,Xt=l(),U=n("img"),Zt=l(),W=n("p"),W.innerHTML=Ba,ta=l(),et(N.$$.fragment),aa=l(),at=n("p"),this.h()},l(t){const s=as("svelte-u9bgzb",document.head);u=i(s,"META",{name:!0,content:!0}),s.forEach(a),ot=p(t),tt=i(t,"P",{}),w(tt).forEach(a),rt=p(t),nt(P.$$.fragment,t),ht=p(t),$=i(t,"P",{"data-svelte-h":!0}),m($)!=="svelte-8fcaqu"&&($.innerHTML=da),ct=p(t),y=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),m(y)!=="svelte-1kvrq9v"&&(y.innerHTML=wa),gt=p(t),L=i(t,"P",{"data-svelte-h":!0}),m(L)!=="svelte-kt354t"&&(L.textContent=ba),ut=p(t),nt(H.$$.fragment,t),ft=p(t),x=i(t,"P",{});var ea=w(x);pa=h(ea,"In situations 1 and 2, "),Y=i(ea,"STRONG",{"data-svelte-h":!0}),m(Y)!=="svelte-w52w77"&&(Y.textContent=ya),vt=b(ea,!1),ea.forEach(a),dt=p(t),z=i(t,"P",{"data-svelte-h":!0}),m(z)!=="svelte-1cqqr4g"&&(z.innerHTML=xa),wt=p(t),I=i(t,"P",{"data-svelte-h":!0}),m(I)!=="svelte-jfeco7"&&(I.innerHTML=_a),bt=p(t),O=i(t,"P",{"data-svelte-h":!0}),m(O)!=="svelte-uloelw"&&(O.textContent=ka),yt=p(t),j=i(t,"P",{"data-svelte-h":!0}),m(j)!=="svelte-1ffs0w0"&&(j.innerHTML=Ca),xt=p(t),nt(E.$$.fragment,t),_t=p(t),_=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),m(_)!=="svelte-1kvrq9v"&&(_.innerHTML=Ma),kt=p(t),k=i(t,"P",{});var na=w(k);ma=h(na,"If the probability ratio is lower than"),Ct=b(na,!1),Mt=h(na,", the probability of taking that action at that state is much lower than with the old policy."),na.forEach(a),Tt=p(t),S=i(t,"P",{"data-svelte-h":!0}),m(S)!=="svelte-1x6bxjm"&&(S.innerHTML=Ta),Pt=p(t),q=i(t,"P",{"data-svelte-h":!0}),m(q)!=="svelte-1l49ylb"&&(q.innerHTML=Pa),$t=p(t),nt(A.$$.fragment,t),Lt=p(t),C=i(t,"FIGURE",{class:!0,"data-svelte-h":!0}),m(C)!=="svelte-1kvrq9v"&&(C.innerHTML=$a),Ht=p(t),f=i(t,"P",{});var st=w(f);oa=h(st,"If the probability ratio is higher than"),zt=b(st,!1),It=h(st,", the probability of taking that action at that state in the current policy is "),J=i(st,"STRONG",{"data-svelte-h":!0}),m(J)!=="svelte-qu8nx6"&&(J.textContent=La),st.forEach(a),Ot=p(t),B=i(t,"P",{"data-svelte-h":!0}),m(B)!=="svelte-1ptdkag"&&(B.innerHTML=Ha),jt=p(t),D=i(t,"P",{"data-svelte-h":!0}),m(D)!=="svelte-yugfug"&&(D.textContent=za),Et=p(t),G=i(t,"P",{"data-svelte-h":!0}),m(G)!=="svelte-1eb9ayw"&&(G.innerHTML=Ia),St=p(t),R=i(t,"P",{"data-svelte-h":!0}),m(R)!=="svelte-pg5tgk"&&(R.textContent=Oa),qt=p(t),M=i(t,"UL",{});var ia=w(M);K=i(ia,"LI",{});var fa=w(K);ra=h(fa,"Our ratio is in the range"),At=b(fa,!1),fa.forEach(a),ha=p(ia),Q=i(ia,"LI",{"data-svelte-h":!0}),m(Q)!=="svelte-1hd4gm6"&&(Q.innerHTML=ja),ia.forEach(a),Bt=p(t),c=i(t,"P",{});var v=w(c);X=i(v,"STRONG",{"data-svelte-h":!0}),m(X)!=="svelte-xl5clc"&&(X.textContent=Ea),ca=h(v," When the ratio is clipped, the derivative in this case will not be the derivative of the"),Dt=b(v,!1),Gt=h(v,"   but the derivative of either"),Rt=b(v,!1),Ft=h(v," or the derivative of"),Ut=b(v,!1),Wt=h(v," which both = 0."),v.forEach(a),Nt=p(t),g=i(t,"P",{});var T=w(g);ga=h(T,"To summarize, thanks to this clipped surrogate objective, "),Z=i(T,"STRONG",{"data-svelte-h":!0}),m(Z)!=="svelte-vpub9x"&&(Z.textContent=Sa),ua=h(T," Because we remove the incentive for the probability ratio to move outside of the interval since the clip forces the gradient to be zero. If the ratio is >"),Vt=b(T,!1),Yt=h(T," or <"),Jt=b(T,!1),Kt=h(T," the gradient will be equal to 0."),T.forEach(a),Qt=p(t),F=i(t,"P",{"data-svelte-h":!0}),m(F)!=="svelte-d7ieux"&&(F.textContent=qa),Xt=p(t),U=i(t,"IMG",{src:!0,alt:!0}),Zt=p(t),W=i(t,"P",{"data-svelte-h":!0}),m(W)!=="svelte-enoain"&&(W.innerHTML=Ba),ta=p(t),nt(N.$$.fragment,t),aa=p(t),at=i(t,"P",{}),w(at).forEach(a),this.h()},h(){V(u,"name","hf:doc:metadata"),V(u,"content",ns),V(y,"class","image table text-center m-0 w-full"),vt.a=null,V(_,"class","image table text-center m-0 w-full"),Ct.a=Mt,V(C,"class","image table text-center m-0 w-full"),zt.a=It,At.a=null,Dt.a=Gt,Rt.a=Ft,Ut.a=Wt,Vt.a=Yt,Jt.a=Kt,Ka(U.src,Aa="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/ppo-objective.jpg")||V(U,"src",Aa),V(U,"alt","PPO objective")},m(t,s){o(document.head,u),e(t,ot,s),e(t,tt,s),e(t,rt,s),it(P,t,s),e(t,ht,s),e(t,$,s),e(t,ct,s),e(t,y,s),e(t,gt,s),e(t,L,s),e(t,ut,s),it(H,t,s),e(t,ft,s),e(t,x,s),o(x,pa),o(x,Y),vt.m(Da,x),e(t,dt,s),e(t,z,s),e(t,wt,s),e(t,I,s),e(t,bt,s),e(t,O,s),e(t,yt,s),e(t,j,s),e(t,xt,s),it(E,t,s),e(t,_t,s),e(t,_,s),e(t,kt,s),e(t,k,s),o(k,ma),Ct.m(Ga,k),o(k,Mt),e(t,Tt,s),e(t,S,s),e(t,Pt,s),e(t,q,s),e(t,$t,s),it(A,t,s),e(t,Lt,s),e(t,C,s),e(t,Ht,s),e(t,f,s),o(f,oa),zt.m(Ra,f),o(f,It),o(f,J),e(t,Ot,s),e(t,B,s),e(t,jt,s),e(t,D,s),e(t,Et,s),e(t,G,s),e(t,St,s),e(t,R,s),e(t,qt,s),e(t,M,s),o(M,K),o(K,ra),At.m(Fa,K),o(M,ha),o(M,Q),e(t,Bt,s),e(t,c,s),o(c,X),o(c,ca),Dt.m(Ua,c),o(c,Gt),Rt.m(Wa,c),o(c,Ft),Ut.m(Na,c),o(c,Wt),e(t,Nt,s),e(t,g,s),o(g,ga),o(g,Z),o(g,ua),Vt.m(Va,g),o(g,Yt),Jt.m(Ya,g),o(g,Kt),e(t,Qt,s),e(t,F,s),e(t,Xt,s),e(t,U,s),e(t,Zt,s),e(t,W,s),e(t,ta,s),it(N,t,s),e(t,aa,s),e(t,at,s),sa=!0},p:Qa,i(t){sa||(lt(P.$$.fragment,t),lt(H.$$.fragment,t),lt(E.$$.fragment,t),lt(A.$$.fragment,t),lt(N.$$.fragment,t),sa=!0)},o(t){pt(P.$$.fragment,t),pt(H.$$.fragment,t),pt(E.$$.fragment,t),pt(A.$$.fragment,t),pt(N.$$.fragment,t),sa=!1},d(t){t&&(a(ot),a(tt),a(rt),a(ht),a($),a(ct),a(y),a(gt),a(L),a(ut),a(ft),a(x),a(dt),a(z),a(wt),a(I),a(bt),a(O),a(yt),a(j),a(xt),a(_t),a(_),a(kt),a(k),a(Tt),a(S),a(Pt),a(q),a($t),a(Lt),a(C),a(Ht),a(f),a(Ot),a(B),a(jt),a(D),a(Et),a(G),a(St),a(R),a(qt),a(M),a(Bt),a(c),a(Nt),a(g),a(Qt),a(F),a(Xt),a(U),a(Zt),a(W),a(ta),a(aa),a(at)),a(u),mt(P,t),mt(H,t),mt(E,t),mt(A,t),mt(N,t)}}}const ns='{"title":"Visualize the Clipped Surrogate Objective Function","local":"visualize-the-clipped-surrogate-objective-function","sections":[{"title":"Case 1 and 2: the ratio is between the range","local":"case-1-and-2-the-ratio-is-between-the-range","sections":[],"depth":2},{"title":"Case 3 and 4: the ratio is below the range","local":"case-3-and-4-the-ratio-is-below-the-range","sections":[],"depth":2},{"title":"Case 5 and 6: the ratio is above the range","local":"case-5-and-6-the-ratio-is-above-the-range","sections":[],"depth":2}],"depth":1}';function is(va){return Xa(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class os extends Za{constructor(u){super(),ts(this,u,is,es,Ja,{})}}export{os as component};
